/* (c) https://github.com/MontiCore/monticore */
/* generated by template templates.de.monticore.lang.montiarc.tagschema.TagSchema*/


package nfp.LatencyTagSchema;

import de.monticore.CommonModelingLanguage;
import de.monticore.lang.montiarc.tagging._symboltable.TagableModelingLanguage;
import de.monticore.symboltable.resolving.CommonResolvingFilter;

/**
 * generated by TagSchema.ftl
 */
public class LatencyTagSchema {

  protected static LatencyTagSchema instance = null;

  protected LatencyTagSchema() {}

  protected static LatencyTagSchema getInstance() {
    if (instance == null) {
      instance = new LatencyTagSchema();
    }
    return instance;
  }

  protected void doRegisterTagTypes(TagableModelingLanguage modelingLanguage) {
    // all ModelingLanguage instances are actually instances of CommonModelingLanguage
    if(modelingLanguage instanceof CommonModelingLanguage) {
      CommonModelingLanguage commonModelingLanguage = (CommonModelingLanguage)modelingLanguage;

      modelingLanguage.addTagSymbolCreator(new LatencyCmpInstSymbolCreator());
      commonModelingLanguage.addResolver(CommonResolvingFilter.create(LatencyCmpInstSymbol.KIND));
      modelingLanguage.addTagSymbolCreator(new LatencyCmpSymbolCreator());
      commonModelingLanguage.addResolver(CommonResolvingFilter.create(LatencyCmpSymbol.KIND));
      modelingLanguage.addTagSymbolCreator(new LatencyConnSymbolCreator());
      commonModelingLanguage.addResolver(CommonResolvingFilter.create(LatencyConnSymbol.KIND));
      modelingLanguage.addTagSymbolCreator(new LatencyPortSymbolCreator());
      commonModelingLanguage.addResolver(CommonResolvingFilter.create(LatencyPortSymbol.KIND));

      modelingLanguage.addTagSymbolCreator(new LatencyViewPortSymbolCreator());
      commonModelingLanguage.addResolver(CommonResolvingFilter.create(LatencyViewPortSymbol.KIND));
      modelingLanguage.addTagSymbolCreator(new LatencyViewConnSymbolCreator());
      commonModelingLanguage.addResolver(CommonResolvingFilter.create(LatencyViewConnSymbol.KIND));
      modelingLanguage.addTagSymbolCreator(new LatencyViewEffSymbolCreator());
      commonModelingLanguage.addResolver(CommonResolvingFilter.create(LatencyViewEffSymbol.KIND));
    }
  }

  public static void registerTagTypes(TagableModelingLanguage modelingLanguage) {
    getInstance().doRegisterTagTypes(modelingLanguage);
  }
}
